import { DVEConstructorCore } from "@divinevoxel/core/Interfaces/Constructor/DVEConstructorCore";
import { DVEFDataCore } from "../../Data/DVEFDataCore.js";
import { DVEFConstructorThreads } from "./DVEFConstructorThreads";
import { WorldGeneration } from "./WorldGeneration/WorldGeneration";
import { ConstructorTasks } from "./Tasks/ConstructorTasks";
export class DVEFConstrucotrCore extends DVEConstructorCore {
    static instance;
    tasks;
    threads = new DVEFConstructorThreads();
    data = new DVEFDataCore();
    worldGen = WorldGeneration;
    builder;
    propagation;
    analyzer;
    constructor(data) {
        super();
        if (DVEFConstrucotrCore.instance)
            return DVEFConstrucotrCore.instance;
        DVEFConstrucotrCore.instance = this;
        this.builder = data.builder;
        this.propagation = data.propagation;
        this.analyzer = data.analyzer;
        this.tasks = new ConstructorTasks();
    }
    async init() {
        await this.builder.init();
    }
}
