import { DataLoaderThreads } from "./Threads/DataLoaderThreads.js";
import { RichDataTool } from "../../Default/Tools/Data/RichDataTool.js";
import { DataTool } from "../../Default/Tools/Data/DataTool.js";
import { DataHandler } from "./DataHandler/DataHandlerBaes.js";
import { DVEDataCore } from "@divinevoxel/core/Interfaces/Data/DVEDataCore.js";
export type DivineVoxelEngineDataLoaderInitData = {
    data: DVEDataCore;
    dataHanlder: DataHandler;
};
export declare class DivineVoxelEngineDataLoader {
    static instance: DivineVoxelEngineDataLoader;
    environment: "node" | "browser";
    TC: {
        threadNumber: number;
        threadName: string;
        environment: "node" | "browser";
        _comms: Record<string, import("@divinestar/threads/").CommBase>;
        _commManageras: Record<string, import("@divinestar/threads/").CommManager>;
        _queues: Map<string, Map<string, import("@divinestar/threads/Queue/SyncedQueue.js").SyncedQueue>>;
        parent: import("@divinestar/threads/").CommBase;
        internal: {
            _tasks: Map<number, Map<number, any>>;
            registerTasks(headID: number, taskId: number, run: any): void;
            isInternal(data: any): boolean;
            runInternal(data: any, event: any): false | undefined;
        };
        __initalized: boolean;
        __expectedPorts: Record<string, boolean>;
        crypto: Crypto;
        $INIT(threadName: string, threadParentName: string): Promise<void>;
        getSyncedQueue(threadId: string, queueId: string): import("@divinestar/threads/Queue/SyncedQueue.js").SyncedQueue | undefined;
        addComm(comm: import("@divinestar/threads/").CommBase): void;
        createComm<T>(name: string, mergeObject?: T | undefined): T & import("@divinestar/threads/").CommBase;
        createCommManager(data: import("@divinestar/threads/Meta/Manager/Manager.types.js").CommManagerData): import("@divinestar/threads/").CommManager;
        getComm(id: string): import("@divinestar/threads/").CommBase;
        getCommManager(id: string): import("@divinestar/threads/").CommManager;
        getWorkerPort(): Promise<any>;
        registerTasks<T_1>(id: string | number, run: (data: T_1, onDone?: ((data?: any, transfers?: any) => void) | undefined) => void, mode?: "async" | "deferred" | undefined): void;
        onDataSync<T_2, K>(dataType: string | number, onSync?: ((data: T_2) => void) | undefined, onUnSync?: ((data: K) => void) | undefined): any;
    };
    data: DVEDataCore;
    threads: DataLoaderThreads;
    constructor(data: DivineVoxelEngineDataLoaderInitData);
    tasks: {
        loadRegionHeader: void;
        saveColumn: void;
        loadColumn: void;
        unLoadColumn: void;
        setPath: void;
        columnExists: void;
        columnTimestamp: void;
    };
    serializer: {
        regions: import("Default/Tools/Data/WorldData/RegionDataTool.js").RegionDataTool;
        columns: import("Default/Tools/Data/WorldData/ColumnDataTool.js").ColumnDataTool;
        chunks: import("Default/Tools/Data/WorldData/ChunkDataTool.js").ChunkDataTool;
        serializeRegion(location: import("@divinevoxel/core/Math/index.js").LocationData): false | [location: import("@divinevoxel/core/Math/index.js").LocationData, buffer: ArrayBuffer][];
        serializeColumn(location: import("@divinevoxel/core/Math/index.js").LocationData): false | Uint8Array;
        deSerializeRegion(regionBuffers: ArrayBuffer[] | SharedArrayBuffer[]): void;
        deSerializeColumn(columnBuffer: ArrayBuffer | SharedArrayBuffer): {
            column: SharedArrayBuffer;
            chunks: SharedArrayBuffer[];
        };
        _readDataIntoBuffer(offset: number, target: Uint8Array, source: ArrayBuffer | SharedArrayBuffer, sourceOffset?: number, sourceLength?: number): number;
    };
    dataHandler: {
        mode: import("./DataHandler/DataHandlerBaes.js").DataLoaderModes;
        handler: DataHandler;
        richData: RichDataTool;
        $INIT(handler: DataHandler): void;
        loadRegionHeader(location: import("@divinevoxel/core/Math/index.js").LocationData): Promise<boolean>;
        saveColumn(location: import("@divinevoxel/core/Math/index.js").LocationData): Promise<boolean | undefined>;
        loadColumn(location: import("@divinevoxel/core/Math/index.js").LocationData): Promise<boolean>;
        unLoadColumn(location: import("@divinevoxel/core/Math/index.js").LocationData): Promise<true | undefined>;
        setPath(id: string): Promise<boolean>;
        columnExists(location: import("@divinevoxel/core/Math/index.js").LocationData): Promise<boolean>;
        columnTimestamp(location: import("@divinevoxel/core/Math/index.js").LocationData): Promise<number>;
    };
    init(): Promise<void>;
    getRichDataTool(): RichDataTool;
    getDataTool(): DataTool;
}
