import { Chunk } from "./World/Classes/Chunk.js";
import { Column } from "./World/Classes/Column.js";
import { Region } from "./World/Classes/Region.js";
import { DVEFDataSyncNode } from "./DVEFDataSyncNode.js";
import { DataManager } from "@divinevoxel/core/Interfaces/Data/DataManager.js";
export declare class DVEFDataManager extends DataManager {
    world: {
        _currentionDimension: string;
        paint: {
            _dt: import("Default/Tools/Data/DataTool.js").DataTool;
            voxel(location: import("@divinevoxel/core/Math/index.js").LocationData, data: import("Data/Types/WorldData.types.js").AddVoxelData, update?: boolean): void;
            __paint(location: import("@divinevoxel/core/Math/index.js").LocationData, data: import("Data/Types/WorldData.types.js").AddVoxelData, update?: boolean): false | undefined;
            erase(location: import("@divinevoxel/core/Math/index.js").LocationData): void;
        };
    };
    dataSync: DVEFDataSyncNode;
    registers: {
        dimensions: {
            _count: number;
            dimensionRecord: Record<string, number>;
            dimensionMap: Record<number, string>;
            __defaultDimensionOptions: import("Data/Types/DimensionData.types.js").DimensionOptions;
            _dimensions: Record<string, import("Data/Types/DimensionData.types.js").DimensionData>;
            registerDimension(id: string, option: import("Data/Types/DimensionData.types.js").DimensionOptions): void;
            getDimension(id: string | number): import("Data/Types/DimensionData.types.js").DimensionData;
            getDimensionStringId(id: string | number): string;
            getDimensionNumericId(id: string | number): number;
        };
        world: {
            _dimensions: Map<string, import("Data/World/Classes/Dimension.js").Dimension>;
            _cacheOn: boolean;
            _chunkCache: Map<string, Chunk>;
            _columnCache: Map<string, Column>;
            cache: {
                enable(): void;
                disable(): void;
                _addChunk(key: string, data: Chunk): void;
                _addColumn(key: string, data: Column): void;
                _getChunk(key: string): Chunk | undefined;
                _getColumn(key: string): Column | undefined;
            };
            dimensions: {
                add(id: string | number): import("Data/World/Classes/Dimension.js").Dimension;
                get(id: string | number): import("Data/World/Classes/Dimension.js").Dimension | undefined;
            };
            clearAll(): void;
            region: {
                add(location: import("@divinevoxel/core/Math/index.js").LocationData, region: Region): Region;
                get(location: import("@divinevoxel/core/Math/index.js").LocationData): false | Region;
                remove(location: import("@divinevoxel/core/Math/index.js").LocationData): boolean;
            };
            column: {
                add(location: import("@divinevoxel/core/Math/index.js").LocationData, column: Column): Column | undefined;
                get(location: import("@divinevoxel/core/Math/index.js").LocationData): false | Column;
                remove(location: import("@divinevoxel/core/Math/index.js").LocationData): boolean;
                fill(location: import("@divinevoxel/core/Math/index.js").LocationData): void;
            };
            chunk: {
                add(location: import("@divinevoxel/core/Math/index.js").LocationData, chunk: Chunk): Chunk | undefined;
                get(location: import("@divinevoxel/core/Math/index.js").LocationData): false | Chunk | undefined;
                remove(location: import("@divinevoxel/core/Math/index.js").LocationData): boolean;
            };
        };
        regionHeader: {
            _headers: Map<string, Map<string, {
                data: DataView;
                buffer: SharedArrayBuffer;
            }>>;
            remove(location: import("@divinevoxel/core/Math/index.js").LocationData): boolean;
            add(location: import("@divinevoxel/core/Math/index.js").LocationData, buffer: SharedArrayBuffer): void;
            get(location: import("@divinevoxel/core/Math/index.js").LocationData): false | {
                data: DataView;
                buffer: SharedArrayBuffer;
            } | undefined;
            isStored(location: import("@divinevoxel/core/Math/index.js").LocationData): 1 | -1 | 0;
        };
    };
    worldDataTags: {
        chunks: import("@divinestar/binary").RemoteTagManager;
        column: import("@divinestar/binary").RemoteTagManager;
        region: import("@divinestar/binary").RemoteTagManager;
    };
}
