import { Chunk, Column, Dimension, Region } from "./Classes/";
import type { LocationData } from "@divinevoxel/core/Math";
export declare const WorldRegister: {
    _dimensions: Map<string, Dimension>;
    _cacheOn: boolean;
    _chunkCache: Map<string, Chunk>;
    _columnCache: Map<string, Column>;
    cache: {
        enable(): void;
        disable(): void;
        _addChunk(key: string, data: Chunk): void;
        _addColumn(key: string, data: Column): void;
        _getChunk(key: string): Chunk | undefined;
        _getColumn(key: string): Column | undefined;
    };
    dimensions: {
        add(id: number | string): Dimension;
        get(id: number | string): Dimension | undefined;
    };
    clearAll(): void;
    region: {
        add(location: LocationData, region: Region): Region;
        get(location: LocationData): false | Region;
        remove(location: LocationData): boolean;
    };
    column: {
        add(location: LocationData, column: Column): Column | undefined;
        get(location: LocationData): false | Column;
        remove(location: LocationData): boolean;
        fill(location: LocationData): void;
    };
    chunk: {
        add(location: LocationData, chunk: Chunk): Chunk | undefined;
        get(location: LocationData): false | Chunk | undefined;
        remove(location: LocationData): boolean;
    };
};
