import { EntityBase } from "../../Physics/Entities/EntityBase.js";
import { Vector3 } from "@divinevoxel/core/Math/index.js";
import { PlayerPhysicsData } from "../Data/PlayerPhysicsData.js";
import { PlayerStatsData } from "../Data/PlayerStatsData.js";
import { ValueEaseAndTween } from "../../Math/EaseAndTween.js";
export declare class NexusPlayer extends EntityBase {
    physics: PlayerPhysicsData;
    stats: PlayerStatsData;
    states: {
        cilmbingStair: boolean;
        inWater: boolean;
        onLadder: boolean;
        gravity: number;
        jumping: boolean;
        canJump: boolean;
        jumpVelocity: number;
        onGround: boolean;
        climbing: boolean;
    };
    get position(): Vector3;
    materialStandingOn: string;
    sideDirection: Vector3;
    forwardDirection: Vector3;
    speed: number;
    runSpeed: number;
    tweens: {
        jump: ValueEaseAndTween;
        fall: ValueEaseAndTween;
        walk: ValueEaseAndTween;
        stop: ValueEaseAndTween;
    };
    constructor(physics: PlayerPhysicsData, stats: PlayerStatsData);
    _lastVelocity: Vector3;
    controlsUpdate(): void;
    getSpeed(): number;
    beforeUpdate(): void;
    afterUpdate(): void;
}
